%%This is a part of multi-layered random forest (MLRF) framework

%aggregate features (for histograms)

function Xnew = featureAggregation(X,level)

    if (~ismember(level,[1 2 3 4 5 6]))
        warning('level should come from 1..6')
        Xnew = X;
    end

%the features represent 64bin histograms-> aggregation requires
%re-normalization 
%level = 1 - sum every second
%level = 2 - sum 4
%level = 3 - sum 8
%level = 4 - sum 16
%level = 5 - sum 32
%level = 6 - sum each histogram

    Xnew = zeros(size(X,1),size(X,2)/2^level);

    for i=1:2^level
        Xnew = Xnew + X(:,i:2^level:size(X,2));
    end

end